<template>
  <!-- 查询和其他操作 -->
  <div class="filter-container" style="margin: 10px 0 10px 0;">
    <el-form :inline="true" label-width="68px" style="margin-bottom: 8px;">
      <el-form-item label="渠道">
        <el-select
          v-model="queryParams.source"
          class="filter-item"
          placeholder="渠道"
          style="width: 140px"
          filterable
          clearable
          remote
          reserve-keyword
        >
          <el-option
            v-for="item in sourceData"
            :key="item.source"
            :label="item.name"
            :value="item.source"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="用户ID">
        <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.openId" placeholder="请输入" />
      </el-form-item>
      <el-form-item label="会员状态">
        <el-select v-model="queryParams.isVip" placeholder="会员状态"  class="filter-item" style="width: 200px;">
          <el-option label="全选" value=""></el-option>
          <el-option label="会员" value="1">会员</el-option>
          <el-option label="非会员" value="0">非会员</el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="瓦力ID">
        <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.uid" placeholder="请输入" />
      </el-form-item>
      <el-form-item label="日期时间">
        <el-date-picker
          v-model="queryParams.beginCreateTime"
          type="datetime"
          placeholder="开始日期"
          class="baseInput"
          format="yyyy-MM-dd HH"
          value-format="yyyy-MM-dd HH"
          style="width: 200px;"
        >
        </el-date-picker>
        <span> - </span>
        <el-date-picker
          v-model="queryParams.endCreateTime"
          type="datetime"
          placeholder="结束日期"
          class="baseInput"
          format="yyyy-MM-dd HH"
          value-format="yyyy-MM-dd HH"
          style="width: 200px;"
        >
        </el-date-picker>
      </el-form-item>
      <el-form-item label="状态">
        <el-select v-model="queryParams.isBlack" placeholder="状态"  class="filter-item" style="width: 200px;">
          <el-option label="全选" value="-1"></el-option>
          <el-option label="正常" value="0">正常</el-option>
          <el-option label="冻结" value="1">冻结</el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="one冻结">
        <el-select v-model="queryParams.isOneMember " placeholder="全选"  class="filter-item" style="width: 200px;">
          <el-option label="全选" value="-1" ></el-option>
          <el-option label="是" value="2">是</el-option>
          <el-option label="否" value="1">否</el-option>
        </el-select>
      </el-form-item>
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFind">筛选</el-button>
      <el-button class="filter-item" type="primary" icon="el-icon-s-flag" @click="exportData">导出</el-button>
    </el-form>
    <el-table :data="tableData" style="width:100%" class="show_table" >
      <el-table-column label="用户来源" style="width:5%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.sourceName }}</span>
        </template>
      </el-table-column>
      <el-table-column label="用户ID" style="width:10%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.openId }}</span>
        </template>
      </el-table-column>
      <el-table-column label="瓦利ID" style="width:10%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.uid }}</span>
        </template>
      </el-table-column>
      <el-table-column label="用户昵称" style="width:10%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.loginName }}</span>
        </template>
      </el-table-column>
      <el-table-column label="会员状态" style="width:15%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span v-if="scope.row.isVip == 1">会员</span>
          <span v-if="scope.row.isVip == 0 || scope.row.isVip == ''">非会员</span>
        </template>
      </el-table-column>
      <el-table-column label="持有金币余额" style="width:6%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.coins }}</span>
        </template>
      </el-table-column>
      <el-table-column label="绑定手机号" style="width:6%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.phone }}</span>
        </template>
      </el-table-column>
      <el-table-column label="建立时间" style="width:15%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.createTime }}</span>
        </template>
      </el-table-column>
      <el-table-column label="累存金额" style="width:6%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.sumAmount }}</span>
        </template>
      </el-table-column>
      <el-table-column label="one用户" width="100">
        <template slot-scope="scope">
          <template v-if="scope.row.isOneMember == 1">
            <span>是</span>
          </template>
          <template v-if="scope.row.isOneMember == 0">
            <span>否</span>
          </template>
          <template v-if="scope.row.isOneMember == 2">
            <span>one冻结</span>
          </template>
        </template>
      </el-table-column>
      <el-table-column label="建立时间" style="width:15%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.createTime }}</span>
        </template>
      </el-table-column>
      <el-table-column label="状态" style="width:15%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span v-if="scope.row.isBlack == 1">冻结</span>
          <span v-if="scope.row.isBlack == 0">正常</span>
        </template>
      </el-table-column>
      <el-table-column  label="冻结操作" fixed="right" style="width:3%">
        <template slot-scope="scope" >

          <el-button v-if="scope.row.isOneMember==1" @click="handleOne(scope.row,2)" type="primary" size="small">one冻结</el-button>
          <el-button v-if="scope.row.isOneMember==2" @click="handleOne(scope.row,1)" type="primary" size="small">one解冻</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-sizes="[40, 80, 120, 200]"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>
    <el-dialog title="编辑" :visible.sync="dialogFormVisible" :before-close="handleClose" width="40%">
      <el-form :model="form" ref="form">
        <el-form-item label="瓦力ID:" v-if="form.uid" :label-width="formLabelWidth">
          <span>{{form.uid}}</span>
        </el-form-item>
        <el-form-item label="手机号:" :label-width="formLabelWidth">
          <span>{{form.phone}}</span>
        </el-form-item>
        <el-form-item label="拉黑原因：" :label-width="formLabelWidth" prop="reason">
          <textarea v-model="form.reason" type="text" auto-complete="off" style="width: 80%;height: 100px"></textarea>
        </el-form-item>
        <el-form-item label="冻结开关" :label-width="formLabelWidth" prop="isBlack">
          <el-switch v-model="form.isBlack"
                     active-color="#13ce66"
                     inactive-color="#ff4949"
                     active-text="冻结"
                     inactive-text="不冻结"
                     :active-value="1"
                     :inactive-value="0" >
          </el-switch>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="handleClose">取 消</el-button>
        <el-button type="primary" @click="submitForm">确 定</el-button>
      </div>
    </el-dialog>
    <el-dialog title="操作纪录" :visible.sync="dialogLogVisible" :before-close="handleLogClose" width="50%" >
      <el-table :data="logData" style="width:100%" class="show_table" >
        <el-table-column label="操作员" style="width:5%" :show-overflow-tooltip="true" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.userName }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作时间" style="width:15%" :show-overflow-tooltip="true" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.updateTime }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作內容" style="width:20%" :show-overflow-tooltip="true" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.content }}</span>
          </template>
        </el-table-column>
      </el-table>
    </el-dialog>
  </div>
</template>

<script>
  import {dateFormat} from "@/utils/webUtils.js"
  import {getPandaUserList,getSourceList,getBlacklist,editBlacklist,getLogList,editOne} from "@/api/pandaUsers";
  import {
    export_json_to_excel
  } from "@/vendor/Export2Excel";
  export default {
    data() {
      return {
        sourceData: [
          {
            name:'全选',
            source:''}
        ],
        queryParams:{//查询参数
          source: "",//订单ID
          openId: "", //用户ID
          uid: "",
          beginCreateTime: dateFormat("YYYY-mm-dd 00", new Date()),
          endCreateTime: dateFormat("YYYY-mm-dd 23", new Date()),
          isOneMember:"-1"
        },
        form: {
          uid: null,
          phone: null,
          reason: null,
          isBlack: null,
        },
        tableData: [],
        logData: [],
        currentPage: 1,
        pageSize: 40,
        total: 0, //总数量
        orderByDescColumn: "", // 降序字段
        orderByAscColumn: "", // 升序字段
        dialogFormVisible: false, //控制弹出框
        dialogLogVisible: false, //控制弹出框
      };
    },

    created() {
      this.pandaUsersList();
      this.sourceList();
    },
    methods: {
      pandaUsersList: function() {
        this.queryParams.currentPage = this.currentPage;
        this.queryParams.pageSize = this.pageSize;
        this.queryParams.orderByDescColumn = this.orderByDescColumn
        this.queryParams.orderByAscColumn = this.orderByAscColumn
        getPandaUserList(this.queryParams).then(response => {
          this.tableData = response.data.records;
          this.currentPage = response.data.current;
          this.pageSize = response.data.size;
          this.total = response.data.total;
        });
      },

      sourceList: function() {
        var sourceParams = {};
        sourceParams.pageSize = 1000;
        sourceParams.currentPage = 1;
        getSourceList(sourceParams).then(response => {
          this.sourceData.push(...response.data.records);
        });
      },

      handleFind: function() {
        this.currentPage = 1
        this.pandaUsersList();
      },
      handleEdit: function(row) {
        var params = {};
        params.valiUid = row.uid;
        getBlacklist(params).then(response => {
          row.isBlack = response.data.isBlack;
          row.reason  = response.data.reason;
          this.dialogFormVisible = true;
          this.form = row;
        });
      },
      handleOne: function(data,status){
        data.isOneMember=status
        editOne(data).then(response => {
          this.$commonUtil.message.success(response.message)
          this.pandaUsersList();
        });
      },
      handleLook: function(row) {
        var params = {};
        params.valiUid = row.uid;
        getLogList(params).then(response => {
          this.logData = response.data;
        });
        this.dialogLogVisible=true;
      },
      submitForm: function() {
        this.$refs.form.validate((valid) => {
          if(!valid) {
            console.log('校验失败')
            return;
          } else {
            var editParams = {};
            editParams.valiUid = this.form.uid;
            editParams.phone = this.form.phone;
            editParams.reason = this.form.reason;
            editParams.isBlack = this.form.isBlack;
            editBlacklist(editParams).then(response => {
              if (response.code == this.$ECode.SUCCESS) {
                this.$commonUtil.message.success(response.message)
                this.dialogFormVisible = false;
              } else {
                this.$commonUtil.message.error(response.message)
              }
            });
          }
        })
      },
      handleSizeChange(val) {
        this.pageSize = val;
        this.pandaUsersList();
      },
      handleCurrentChange: function(val) {
        this.currentPage = val;
        this.pandaUsersList();
      },
      handleSelectionChange(val) {
        this.multipleSelection = val;
      },
      handleClose(){
        this.dialogFormVisible = false;
      },
      handleLogClose(){
        this.dialogLogVisible = false;
      },
      // 导出excel数据
      exportData() {
        // 表头对应关系
        const headers = {
          '用户来源': 'sourceName',
          '用户ID': 'openId',
          '瓦利ID': 'uid',
          '用户昵称': 'loginName',
          '会员状态': 'isVip',
          '持有金币余额': 'coins',
          '绑定手机号': 'phone',
          '建立时间': 'createTime',
          '累计金额': 'sumAmount',
          '状态': 'isBlack',
        }
        this.queryParams.currentPage = 1;
        this.queryParams.pageSize = -1;
        this.queryParams.orderByDescColumn = this.orderByDescColumn
        this.queryParams.orderByAscColumn = this.orderByAscColumn
        getPandaUserList(this.queryParams).then(response => {
          const data = this.formatJson(headers, response.data.records)
          export_json_to_excel(Object.keys(headers), data, '用户列表')
        });
      },
      // 该方法负责将数组转化成二维数组
      formatJson(headers, rows) {
        // 首先遍历数组
        return rows.map(item => {
          return Object.keys(headers).map(key => {
            if((headers[key] === 'isVip')){
              if(item[headers[key]] ===1){
                return '会员';
              }else{
                return '非会员';
              }
            }
            if((headers[key] === 'isBlack')){
              if(item[headers[key]] ===1){
                return '冻结';
              }else{
                return '正常';
              }
            }
            return item[headers[key]]
          })
        })
      },

    }
  };
</script>

<style scoped>

</style>
